#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "mys.h"
#include "3d.h"


struct objekt {
  bod A;
  vektor v;
  tip m;
};

struct koule:objekt {
  tip r;
  char c;

  koule(void) {
	bod P;
	vektor e;
	P.x = 0; P.y = 0; P.z = 0;
	e.x = 0; e.y = 0; e.z = 0;
	koule(P, e, 0, 0);
  }

  koule(bod Ai, vektor vi, tip mi, tip ri) {
	A = Ai;
	v = vi;
	m = mi;
	r = ri;
  }

  void move(void) {
	A.x += v.x;
	A.y += v.y;
	A.z += v.z;
  }

  void paint(void) {
	setcolor(15);
	circle(A.x, A.y, r);
  }

  void erase(void) {
	setcolor(0);
	circle(A.x, A.y, r);
  }

};

int inarea(koule *f, koule *s) {
  tip min, odm;
  vektor q;
  q.x = (*f).A.x + (*f).v.x - (*s).A.x - (*s).v.x;
  q.y = (*f).A.y + (*f).v.y - (*s).A.y - (*s).v.y;
  q.z = (*f).A.z + (*f).v.z - (*s).A.z - (*s).v.z;
  min = ((*f).r + (*s).r);
  if ((q.x < min)&&(q.y < min)&&(q.z < min)) {
	odm = q.x*q.x + q.y*q.y + q.z*q.z;
	tip d;
	if (odm >= 0) d = sqrt(odm);
	if ((d < min)&&(d > (min*0.5))) return(1);
	else return(0);
  }
  else return(0);
}

void odraz(koule *f, koule *s) {
  bod A, B;
  vektor q, v, w;
  tip c, tv, tw, m1, m2, Rv, Rw, t;

  t = 0.9;

  A = (*f).A;
  B = (*s).A;
  (*f).v.x *= t;
  (*f).v.y *= t;
  (*f).v.z *= t;
  (*s).v.x *= t;
  (*s).v.y *= t;
  (*s).v.z *= t;
  v = (*f).v;
  w = (*s).v;
  m1 = (*f).m;
  m2 = (*s).m;

  q.x = A.x - B.x;
  q.y = A.y - B.y;
  q.z = A.z - B.z;


  c = 1/((q.x*q.x + q.y*q.y + q.z*q.z)*( m1 + m2 ));
  tv = (v.x*q.x + v.y*q.y + v.z*q.z);
  tw = (w.x*q.x + w.y*q.y + w.z*q.z);

  Rv = 2*m2*(tw - tv)*c;
  Rw = 2*m1*(tv - tw)*c;

  (*f).v.x += q.x*Rv;
  (*f).v.y += q.y*Rv;
  (*f).v.z += q.z*Rv;

  (*s).v.x += q.x*Rw;
  (*s).v.y += q.y*Rw;
  (*s).v.z += q.z*Rw;

  sound(500);
  delay(5);
  nosound();
}

#define POC 9
#define MAXX 639
#define MAXY 349
#define STUX 400
#define STUY 300

void omez(koule *f) {
  if ((*f).A.z < 0) {
	(*f).v.z *= -0.4;
	(*f).A.z = 0.1;
  }
  if ((*f).A.x < -STUX) {
	(*f).v.x *= -0.9;
	(*f).A.x = -STUX + 0.1;
  }
  if ((*f).A.x > STUX) {
	(*f).v.x *= -0.9;
	(*f).A.x = STUX - 0.1;
  }
  if ((*f).A.y > STUY) {
	(*f).v.y *= -0.9;
	(*f).A.y = STUY - 0.1;
  }
  if ((*f).A.y < -STUY) {
	(*f).v.y *= -0.9;
	(*f).A.y = -STUY + 0.1;
  }
/*
  if (abs((*f).v.x) < 0.00001) (*f).v.x = 0;
  if (abs((*f).v.y) < 0.00001) (*f).v.y = 0;
  if (abs((*f).v.z) < 0.00001) (*f).v.z = 0;
*/
}

void main(void) {
int gd = 9, gm = 1;
initgraph(&gd, &gm, "../bgi");
koule k[POC];

char c = 0;
int i = 0, j = 0;

randomize();
for (i = 0; i < POC; i ++) {
  k[i].A.x = random(STUX*2) - STUX;
  k[i].A.y = random(STUY*2) - STUY;
  k[i].A.z = random(200);
  k[i].v.x = 0;
  k[i].v.y = 0;
  k[i].v.z = 0;
//  k[i].v.x = (tip)(random(100)-50)/200;
//  k[i].v.y = (tip)(random(100)-50)/200;
//  k[i].v.z = (tip)(random(100)-50)/200;
//  k[i].r = random(10);
  k[i].r = 20;
  k[i].m = k[i].r;
  if (i < 5) k[i].c = 12;
  else k[i].c = 11;
}
k[0].c = 15;

mouse mys;
trote kamera;
obod H, R;
bod K;
tip r, d = 600;
tip f = 0;
tip odm;
char ap = 0;

mys.set_off();
kamera.set(0, M_PI, k[0].A.x, k[0].A.y, k[0].A.z, 300);

while (c != 27) {
  for (i = 0; i < POC; i ++) {
	for (j = 0; j < POC; j ++) {
	  if (i != j) {
		if (inarea(&k[i], &k[j])) odraz(&k[i], &k[j]);

		if (k[i].A.z > 0.1) {
		  k[i].v.z -= 0.005;
		}
		else {
		  k[i].v.x *= 0.999;
		  k[i].v.y *= 0.999;
		}
		omez(&k[i]);
	  }
	}
  }
  setactivepage(ap);
  cleardevice();
  for (i = 0; i < POC; i ++) {
	k[i].move();
	prumet(&k[i].A, &H, kamera.B, kamera.up, kamera.vp, d, 0, 1);
	K.x = k[i].A.x + kamera.vp.x*k[i].r;
	K.y = k[i].A.y + kamera.vp.y*k[i].r;
	K.z = k[i].A.z + kamera.vp.z*k[i].r;
	prumet(&K, &R, kamera.B, kamera.up, kamera.vp, d, 0, 1);
	odm =
	  (R.x - H.x)*(R.x - H.x) +
	  (R.y - H.y)*(R.y - H.y) +
	  (R.z - H.z)*(R.z - H.z) ;
	if (odm >= 0) r = sqrt(odm);
	setcolor(k[i].c);
//	setfillstyle(1, k[i].c);
//	fillellipse(H.x+MAXX*0.5, H.y+MAXY*0.5, r, r);
	circle(H.x+MAXX*0.5, H.y+MAXY*0.5, r);
  }
  K.z = -10;
  setcolor(2);

  K.x = -STUX;  K.y = -STUY;
  prumet(&K, &H, kamera.B, kamera.up, kamera.vp, d, 0, 1);
  K.x = STUX;  K.y = -STUY;
  prumet(&K, &R, kamera.B, kamera.up, kamera.vp, d, 0, 1);
  line(H.x+MAXX/2, H.y+MAXY/2, R.x+MAXX/2, R.y+MAXY/2);

  K.x = STUX;  K.y = STUY;
  prumet(&K, &H, kamera.B, kamera.up, kamera.vp, d, 0, 1);
  line(H.x+MAXX/2, H.y+MAXY/2, R.x+MAXX/2, R.y+MAXY/2);

  K.x = -STUX;  K.y = STUY;
  prumet(&K, &R, kamera.B, kamera.up, kamera.vp, d, 0, 1);
  line(H.x+MAXX/2, H.y+MAXY/2, R.x+MAXX/2, R.y+MAXY/2);

  K.x = -STUX;  K.y = -STUY;
  prumet(&K, &H, kamera.B, kamera.up, kamera.vp, d, 0, 1);
  line(H.x+MAXX/2, H.y+MAXY/2, R.x+MAXX/2, R.y+MAXY/2);


  setvisualpage(ap);
  ap ++;
  if (ap > 1) ap = 0;
  mys.move();

  kamera.rotate(mys.get_relativex()*0.005);
  kamera.look(mys.get_relativey()*0.005);

  if (kbhit()) c = getch();
  if (c == 'a') {
	kamera.set(kamera.alfa, kamera.beta, k[0].A.x, k[0].A.y, k[0].A.z, kamera.dist);
  }
  if (c == ' ') {
	f = 0;
	while (c != 0) {
	  c = 0;
	  if (kbhit()) c = getch();
	  if (c == ' ') f += 0.001;
	  line(10, 10, 10 + f*500, 10);
	  delay(80);
	}
	k[0].v.x = kamera.up.x*f;
	k[0].v.y = kamera.up.y*f;
	k[0].v.z = kamera.up.z*f;
	c = 0;
  }
  if (c == 13) {
	c = 0;
	cleardevice();
	for(i = 0; i < POC; i ++) {
	  k[i].A.x = random(STUX*2) - STUX;
	  k[i].A.y = random(STUY*2) - STUY;
	  k[i].A.z = random(2000);
	  k[i].v.x = 0;
	  k[i].v.y = 0;
	  k[i].v.z = 0;
	  k[i].r = 20;
	  k[i].m = k[i].r;
	}
  }
  kamera.aktual();
  delay(10);
}


closegraph();
}
