#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

typedef float tip;

struct bod {
  tip x, y, z;
};

struct vektor {
  tip x, y, z;
};

struct objekt {
  bod A;
  vektor v;
  tip m;
};

struct koule:objekt {
  tip r;

  koule(bod Ai, vektor vi, tip mi, tip ri) {
	A = Ai;
	v = vi;
	m = mi;
	r = ri;
  }

  koule(tip x, tip y, tip vx, tip vy, tip mi, tip ri) {
	A.x = x;
	A.y = y;
	v.x = vx;
	v.y = vy;
	m = mi;
	r = ri;
  }

  void move(void) {
	A.x += v.x;
	A.y += v.y;
  }

  void paint(void) {
	setcolor(15);
	circle(A.x, A.y, r);
  }

  void erase(void) {
	setcolor(0);
	circle(A.x, A.y, r);
  }

};

int inarea(koule f, koule s) {
  tip min;
  vektor q;
  q.x = f.A.x - s.A.x;
  q.y = f.A.y - s.A.y;
  tip d = sqrt(q.x*q.x + q.y*q.y);
  min = (f.r + s.r);
  if (d < min) return(1);
  else return(0);
}

void odraz(koule *f, koule *s) {
  bod A, B;
  vektor q, n, v, w;
  tip vq, Kv, Kw, Lv, Lw, m1, m2, Kvn, Kwn;

  A = (*f).A;
  B = (*s).A;
  v = (*f).v;
  w = (*s).v;
  m1 = (*f).m;
  m2 = (*s).m;

  q.x = A.x - B.x;
  q.y = A.y - B.y;

  vq = sqrt(q.x*q.x + q.y*q.y);
  q.x = q.x / vq;
  q.y = q.y / vq;

  n.x = q.y;
  n.y = -q.x;

  Lv = ( q.y*v.x - q.x*v.y )/( q.y*n.x - q.x*n.y );
  Kv = ( n.y*v.x - n.x*v.y )/( n.y*q.x - n.x*q.y );

  setcolor(12);
  line(A.x, A.y, A.x + q.x*Kv*10, A.y + q.y*Kv*10);
  line(A.x, A.y, A.x + n.x*Lv*10, A.y + n.y*Lv*10);

  Lw = ( q.y*w.x - q.x*w.y )/( q.y*n.x - q.x*n.y );
  Kw = ( n.y*w.x - n.x*w.y )/( n.y*q.x - n.x*q.y );

  setcolor(12);
  line(B.x, B.y, B.x + q.x*Kw*10, B.y + q.y*Kw*10);
  line(B.x, B.y, B.x + n.x*Lw*10, B.y + n.y*Lw*10);

  Kvn = ( (m1 - m2)*Kv + 2*m2*Kw )/( m1 + m2 );
  Kwn = ( (m2 - m1)*Kw + 2*m1*Kv )/( m1 + m2 );

  (*f).v.x = Lv*n.x + Kvn*q.x;
  (*f).v.y = Lv*n.y + Kvn*q.y;

  (*s).v.x = Lw*n.x + Kwn*q.x;
  (*s).v.y = Lw*n.y + Kwn*q.y;

}

void main(void) {
int gd = 0, gm = 0;
initgraph(&gd, &gm, "../bgi");

koule k0(30, 200, 0.5, 0, 30, 30);
koule k1(200, 200, 0.2, 0.05, 20, 20);
char c = 0;

while (c != 27) {
  k0.erase();
  k0.move();
  k0.paint();
  k1.erase();
  k1.move();
  k1.paint();
  if (inarea(k0, k1)) odraz(&k0, &k1);
  if (kbhit()) c = getch();
  delay(5);
}



closegraph();
}
