#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

typedef float tip;

struct bod {
  tip x, y, z;
};

struct vektor {
  tip x, y, z;
};

struct objekt {
  bod A;
  vektor v;
  tip m;
};

struct koule:objekt {
  tip r;

  koule(void) {
	koule(0, 0, 0, 0, 0, 0);
  }

  koule(tip x, tip y, tip vx, tip vy, tip mi, tip ri) {
	A.x = x;
	A.y = y;
	v.x = vx;
	v.y = vy;
	m = mi;
	r = ri;
  }

  void move(void) {
	A.x += v.x;
	A.y += v.y;
  }

  void paint(void) {
	setcolor(15);
	circle(A.x, A.y, r);
  }

  void erase(void) {
	setcolor(0);
	circle(A.x, A.y, r);
  }

};

int inarea(koule f, koule s) {
  tip min;
  vektor q;
  q.x = f.A.x + f.v.x - s.A.x - s.v.x;
  q.y = f.A.y + f.v.y - s.A.y - s.v.y;
  min = (f.r + s.r);
  if ((q.x < min)&&(q.y < min)) {
	tip d = sqrt(q.x*q.x + q.y*q.y);
	if (d < min) return(1);
	else return(0);
  }
  else return(0);
}

void odraz(koule *f, koule *s) {
  bod A, B;
  vektor q, v, w;
  tip vq, Kv, Kw, Lv, Lw, m1, m2, Kvn, Kwn;

  A = (*f).A;
  B = (*s).A;
  v.x = (*f).v.x*0.8;
  v.y = (*f).v.y*0.8;
  w.x = (*s).v.x*0.8;
  w.y = (*s).v.y*0.8;
  m1 = (*f).m;
  m2 = (*s).m;

  q.x = A.x - B.x;
  q.y = A.y - B.y;

  vq = 1/sqrt(q.x*q.x + q.y*q.y);
  q.x = q.x * vq;
  q.y = q.y * vq;

  vq = 1/( q.y*q.y + q.x*q.x );

  Lv = ( q.y*v.x - q.x*v.y ) * vq;
  Lw = ( q.y*w.x - q.x*w.y ) * vq;
  Kv = ( q.x*v.x + q.y*v.y ) * vq;
  Kw = ( q.x*w.x + q.y*w.y ) * vq;

  vq = 1/( m1 + m2 );

  Kvn = ( (m1 - m2)*Kv + 2*m2*Kw )*vq;
  Kwn = ( (m2 - m1)*Kw + 2*m1*Kv )*vq;

  (*f).v.x = Kvn*q.x + Lv*q.y;
  (*f).v.y = Kvn*q.y - Lv*q.x;

  (*s).v.x = Kwn*q.x + Lw*q.y;
  (*s).v.y = Kwn*q.y - Lw*q.x;

}

#define POC 20
#define MAXX 600
#define MAXY 400


void okraj(koule *k) {
  if ((*k).A.x < 10) {
	(*k).v.x *= -0.8;
	(*k).A.x = 10;
  }
  if ((*k).A.y < 10) {
	(*k).v.y *= -0.8;
	(*k).A.y = 10;
  }
  if ((*k).A.x > MAXX) {
	(*k).v.x *= -0.8;
	(*k).A.x = MAXX;
  }
  if ((*k).A.y > MAXY) {
	(*k).v.y *= -0.8;
	(*k).A.y = MAXY;
  }
}

void main(void) {
int gd = 0, gm = 0;
initgraph(&gd, &gm, "../bgi");

koule k[POC];

char c = 0;
int i = 0, j = 0;

randomize();
for (i = 0; i < POC; i ++) {
  k[i].A.x = random(MAXX);
  k[i].A.y = random(MAXY);
  k[i].v.x = (tip)(random(100)-50)/200;
  k[i].v.y = (tip)(random(100)-50)/200;
  k[i].r = random(40);
  k[i].m = k[i].r;
}

while (c != 27) {
  for (i = 0; i < POC; i ++) {
	k[i].erase();
//	okraj(&k[i]);
	k[i].move();
	k[i].paint();
	for (j = 0; j < POC; j ++) {
	  if (i != j) {
		k[i].v.x += (k[j].A.x - k[i].A.x)*0.000001*k[j].m;
		k[i].v.y += (k[j].A.y - k[i].A.y)*0.000001*k[j].m;
		if (inarea(k[i], k[j])) odraz(&k[i], &k[j]);
	  }
	}
  }
  if (kbhit()) c = getch();
  if (c == 13) {
	c = 0;
	cleardevice();
	for (i = 0; i < POC; i ++) {
	  k[i].A.x = random(MAXX);
	  k[i].A.y = random(MAXY);
//	  k[i].v.x = (tip)(random(100)-50)/200;
//	  k[i].v.y = (tip)(random(100)-50)/200;
	  k[i].v.x = 0;
	  k[i].v.y = 0;
	  k[i].r = random(40)/10;
	  k[i].m = k[i].r;
	}
  }
//  delay(5);
}



closegraph();
}
