#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

typedef float tip;

struct bod {
  tip x, y, z;
};

struct vektor {
  tip x, y, z;
};

struct objekt {
  bod A;
  vektor v;
  tip m;
};

struct koule:objekt {
  tip r;

  koule(void) {
	bod P;
	vektor e;
	P.x = 0; P.y = 0; P.z = 0;
	e.x = 0; e.y = 0; e.z = 0;
	koule(P, e, 0, 0);
  }

  koule(bod Ai, vektor vi, tip mi, tip ri) {
	A = Ai;
	v = vi;
	m = mi;
	r = ri;
  }

  void move(void) {
	A.x += v.x;
	A.y += v.y;
	A.z += v.z;
  }

  void paint(void) {
	setcolor(15);
	circle(A.x, A.y, r);
  }

  void erase(void) {
	setcolor(0);
	circle(A.x, A.y, r);
  }

};

int inarea(koule *f, koule *s) {
  tip min;
  vektor q;
  q.x = (*f).A.x + (*f).v.x - (*s).A.x - (*s).v.x;
  q.y = (*f).A.y + (*f).v.y - (*s).A.y - (*s).v.y;
  q.z = (*f).A.z + (*f).v.z - (*s).A.z - (*s).v.z;
  min = ((*f).r + (*s).r);
  if ((q.x < min)&&(q.y < min)&&(q.z < min)) {
	tip d = sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
	if ((d < min)&&(d > (min*0.5))) return(1);
	else return(0);
  }
  else return(0);
}

void odraz(koule *f, koule *s) {
  bod A, B;
  vektor q, v, w;
  tip c, tv, tw, m1, m2, Rv, Rw, t;

  t = 0.8;

  A = (*f).A;
  B = (*s).A;
  (*f).v.x *= t;
  (*f).v.y *= t;
  (*f).v.z *= t;
  (*s).v.x *= t;
  (*s).v.y *= t;
  (*s).v.z *= t;
  v = (*f).v;
  w = (*s).v;
  m1 = (*f).m;
  m2 = (*s).m;

  q.x = A.x - B.x;
  q.y = A.y - B.y;
  q.z = A.z - B.z;


  c = 1/((q.x*q.x + q.y*q.y + q.z*q.z)*( m1 + m2 ));
  tv = (v.x*q.x + v.y*q.y + v.z*q.z);
  tw = (w.x*q.x + w.y*q.y + w.z*q.z);

  Rv = 2*m2*(tw - tv)*c;
  Rw = 2*m1*(tv - tw)*c;

  (*f).v.x += q.x*Rv;
  (*f).v.y += q.y*Rv;
  (*f).v.z += q.z*Rv;

  (*s).v.x += q.x*Rw;
  (*s).v.y += q.y*Rw;
  (*s).v.z += q.z*Rw;

}

#define POC 30
#define MAXX 600
#define MAXY 400


void main(void) {
int gd = 0, gm = 0;
initgraph(&gd, &gm, "../bgi");
koule k[POC];

char c = 0;
int i = 0, j = 0;

randomize();
for (i = 0; i < POC; i ++) {
  k[i].A.x = random(MAXX);
  k[i].A.y = random(MAXY);
  k[i].A.z = random(MAXY);
  k[i].v.x = (tip)(random(100)-50)/200;
  k[i].v.y = (tip)(random(100)-50)/200;
  k[i].v.z = (tip)(random(100)-50)/200;
  k[i].r = random(10);
  k[i].m = k[i].r;
}


while (c != 27) {
  for (i = 0; i < POC; i ++) {
	k[i].erase();
	k[i].move();
	k[i].paint();
	for (j = 0; j < POC; j ++) {
	  if (i != j) {
		k[i].v.x += (k[j].A.x - k[i].A.x)*0.000001*k[j].m;
		k[i].v.y += (k[j].A.y - k[i].A.y)*0.000001*k[j].m;
		k[i].v.z += (k[j].A.z - k[i].A.z)*0.000001*k[j].m;
		if (inarea(&k[i], &k[j])) odraz(&k[i], &k[j]);
	  }
	}
  }
  if (kbhit()) c = getch();
  if (c == 13) {
	c = 0;
	cleardevice();
	for (i = 0; i < POC; i ++) {
	  k[i].A.x = random(MAXX);
	  k[i].A.y = random(MAXY);
//	  k[i].A.z = random(MAXY);
	  k[i].A.z = 0;
//	  k[i].v.x = (tip)(random(100)-50)/200;
//	  k[i].v.y = (tip)(random(100)-50)/200;
//	  k[i].v.z = (tip)(random(100)-50)/200;
	  k[i].v.x = 0;
	  k[i].v.y = 0;
	  k[i].v.z = 0;
	  k[i].r = random(10);
	  k[i].m = k[i].r;
	}
  }
  delay(5);
}



closegraph();
}
